Index: /trunk/XTIDE_Universal_BIOS/Inc/ModuleDependency.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/ModuleDependency.inc	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Inc/ModuleDependency.inc	(revision 589)
@@ -26,5 +26,4 @@
 %endif
 
-
 %ifdef MODULE_SERIAL_FLOPPY
 	%ifndef MODULE_SERIAL
@@ -41,5 +40,4 @@
 %endif
 
-; Include module specific .INC files
 %ifdef MODULE_8BIT_IDE
 	%include "IDE_8bit.inc"			; For IDE 8-bit data port macros
@@ -47,4 +45,7 @@
 
 %ifdef MODULE_ADVANCED_ATA
+	%ifndef USE_386
+		%error "MODULE_ADVANCED_ATA requires USE_386!"
+	%endif
 	%include "AdvancedID.inc"
 	%include "PDC20x30.inc"			; For Promise PDC 20230-C and 20630 controllers
@@ -79,49 +80,49 @@
 ; Included modules for ROMVARS.wFlags
 %ifdef MODULE_8BIT_IDE
-	MAIN_FLG_MODULE_8BIT_IDE	EQU	FLG_ROMVARS_MODULE_8BIT_IDE
+	MAIN_FLG_MODULE_8BIT_IDE			EQU	FLG_ROMVARS_MODULE_8BIT_IDE
 %else
-	MAIN_FLG_MODULE_8BIT_IDE	EQU	0
+	MAIN_FLG_MODULE_8BIT_IDE			EQU	0
 %endif
 
 %ifdef MODULE_ADVANCED_ATA
-	MAIN_FLG_MODULE_ADVANCED_ATA	EQU	FLG_ROMVARS_MODULE_ADVANCED_ATA
+	MAIN_FLG_MODULE_ADVANCED_ATA		EQU	FLG_ROMVARS_MODULE_ADVANCED_ATA
 %else
-	MAIN_FLG_MODULE_ADVANCED_ATA	EQU	0
+	MAIN_FLG_MODULE_ADVANCED_ATA		EQU	0
 %endif
 
 %ifdef MODULE_BOOT_MENU
-	MAIN_FLG_MODULE_BOOT_MENU	EQU	FLG_ROMVARS_MODULE_BOOT_MENU
+	MAIN_FLG_MODULE_BOOT_MENU			EQU	FLG_ROMVARS_MODULE_BOOT_MENU
 %else
-	MAIN_FLG_MODULE_BOOT_MENU	EQU	0
+	MAIN_FLG_MODULE_BOOT_MENU			EQU	0
 %endif
 
 %ifdef MODULE_EBIOS
-	MAIN_FLG_MODULE_EBIOS	EQU	FLG_ROMVARS_MODULE_EBIOS
+	MAIN_FLG_MODULE_EBIOS				EQU	FLG_ROMVARS_MODULE_EBIOS
 %else
-	MAIN_FLG_MODULE_EBIOS	EQU	0
+	MAIN_FLG_MODULE_EBIOS				EQU	0
 %endif
 
 %ifdef MODULE_HOTKEYS
-	MAIN_FLG_MODULE_HOTKEYS	EQU	FLG_ROMVARS_MODULE_HOTKEYS
+	MAIN_FLG_MODULE_HOTKEYS				EQU	FLG_ROMVARS_MODULE_HOTKEYS
 %else
-	MAIN_FLG_MODULE_HOTKEYS	EQU	0
+	MAIN_FLG_MODULE_HOTKEYS				EQU	0
 %endif
 
 %ifdef MODULE_IRQ
-	MAIN_FLG_MODULE_IRQ		EQU	FLG_ROMVARS_MODULE_IRQ
+	MAIN_FLG_MODULE_IRQ					EQU	FLG_ROMVARS_MODULE_IRQ
 %else
-	MAIN_FLG_MODULE_IRQ		EQU	0
+	MAIN_FLG_MODULE_IRQ					EQU	0
 %endif
 
 %ifdef MODULE_SERIAL
-	MAIN_FLG_MODULE_SERIAL	EQU	FLG_ROMVARS_MODULE_SERIAL
+	MAIN_FLG_MODULE_SERIAL				EQU	FLG_ROMVARS_MODULE_SERIAL
 %else
-	MAIN_FLG_MODULE_SERIAL	EQU	0
+	MAIN_FLG_MODULE_SERIAL				EQU	0
 %endif
 
 %ifdef MODULE_SERIAL_FLOPPY
-	MAIN_FLG_MODULE_SERIAL_FLOPPY	EQU	FLG_ROMVARS_MODULE_SERIAL_FLOPPY
+	MAIN_FLG_MODULE_SERIAL_FLOPPY		EQU	FLG_ROMVARS_MODULE_SERIAL_FLOPPY
 %else
-	MAIN_FLG_MODULE_SERIAL_FLOPPY	EQU	0
+	MAIN_FLG_MODULE_SERIAL_FLOPPY		EQU	0
 %endif
 
@@ -145,3 +146,2 @@
 
 MASK_ROMVARS_INCLUDED_MODULES	EQU	MAIN_FLG_MODULE_8BIT_IDE | MAIN_FLG_MODULE_ADVANCED_ATA | MAIN_FLG_MODULE_BOOT_MENU | MAIN_FLG_MODULE_EBIOS | MAIN_FLG_MODULE_HOTKEYS | MAIN_FLG_MODULE_IRQ | MAIN_FLG_MODULE_SERIAL | MAIN_FLG_MODULE_SERIAL_FLOPPY | MAIN_FLG_MODULE_STRINGS_COMPRESSED | MAIN_FLG_MODULE_POWER_MANAGEMENT | MAIN_FLG_MODULE_8BIT_IDE_ADVANCED
-
Index: /trunk/XTIDE_Universal_BIOS/Inc/RamVars.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/RamVars.inc	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Inc/RamVars.inc	(revision 589)
@@ -132,4 +132,6 @@
 %endif
 
+							alignb	2	; Keep the INTPACK structure and stack pointer WORD aligned
+
 	.intpack				resb	INTPACK_size
 endstruc
Index: /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc	(revision 589)
@@ -71,5 +71,6 @@
 												; (Conveniently, this is 8, a fact we exploit when testing the bit)
 
-; Here in case the configuration needs to know functionality is present
+; Here in case the configuration needs to know functionality is present. Note! Changing the order/location of these flags
+; also requires changes elsewhere as they are usually tested using byte-accesses for efficiency.
 FLG_ROMVARS_MODULE_POWER_MANAGEMENT		EQU	(1<<5)
 FLG_ROMVARS_MODULE_8BIT_IDE				EQU	(1<<6)
@@ -146,5 +147,4 @@
 ; Device types for IDEVARS.bDevice
 ; IDE Devices are grouped so device numbers cannot be changed without modifying code elsewhere!
-; (IdeTransfer.asm)
 COUNT_OF_STANDARD_IDE_DEVICES			EQU	2	; 16- and 32-bit controllers
 COUNT_OF_8BIT_IDE_DEVICES				EQU	9
Index: /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeCommand.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeCommand.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeCommand.asm	(revision 589)
@@ -33,6 +33,10 @@
 IdeCommand_ResetMasterAndSlaveController:
 	; HSR0: Set_SRST
-	call	AccessDPT_GetDeviceControlByteToAL
-	or		al, FLG_DEVCONTROL_SRST | FLG_DEVCONTROL_nIEN	; Set Reset bit
+; Used to be:
+;	call	AccessDPT_GetDeviceControlByteToAL
+;	or		al, FLG_DEVCONTROL_SRST | FLG_DEVCONTROL_nIEN	; Set Reset bit
+; Is now:
+	mov		al, FLG_DEVCONTROL_SRST | FLG_DEVCONTROL_nIEN
+; ---
 	OUTPUT_AL_TO_IDE_CONTROL_BLOCK_REGISTER		DEVICE_CONTROL_REGISTER_out
 	mov		ax, HSR0_RESET_WAIT_US
@@ -40,7 +44,11 @@
 
 	; HSR1: Clear_wait
-	call	AccessDPT_GetDeviceControlByteToAL
-	or		al, FLG_DEVCONTROL_nIEN
-	and		al, ~FLG_DEVCONTROL_SRST						; Clear reset bit
+; Used to be:
+;	call	AccessDPT_GetDeviceControlByteToAL
+;	or		al, FLG_DEVCONTROL_nIEN
+;	and		al, ~FLG_DEVCONTROL_SRST						; Clear reset bit
+; Is now:
+	mov		al, FLG_DEVCONTROL_nIEN
+; ---
 	OUTPUT_AL_TO_IDE_CONTROL_BLOCK_REGISTER		DEVICE_CONTROL_REGISTER_out
 	mov		ax, HSR1_RESET_WAIT_US
@@ -51,4 +59,11 @@
 	jmp		IdeWait_PollStatusFlagInBLwithTimeoutInBH
 
+; *FIXME* AccessDPT_GetDeviceControlByteToAL currently always returns with
+; AL cleared (0) or with only bit 1 set (FLG_DEVCONTROL_nIEN = 2).
+; The commented away instructions above sets FLG_DEVCONTROL_nIEN anyway
+; making the call to AccessDPT_GetDeviceControlByteToAL redundant.
+; I have left this code as is since I don't know if it's a mistake
+; (from all the way back to r150) or if it's coded this way in anticipation
+; of some future changes to AccessDPT_GetDeviceControlByteToAL.
 
 ;--------------------------------------------------------------------
Index: /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeDmaBlock.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeDmaBlock.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeDmaBlock.asm	(revision 589)
@@ -94,9 +94,9 @@
 	; When DI is zero only one transfer is required since we've limited the
 	; XT-CFv3 block size to 32k
-	jnc		SHORT .TransferLastDmaPageWithSizeInCX
+	jnc		SHORT StartDMAtransferForXTCFwithDmaModeInBL
 
 	; CF was set, so DI != 0 and we might need one or two transfers
-	cmp		cx, ax									; if we won't cross a physical page boundary...
-	jbe		SHORT .TransferLastDmaPageWithSizeInCX	; ...perform the transfer in one operation
+	cmp		cx, ax											; if we won't cross a physical page boundary...
+	jbe		SHORT StartDMAtransferForXTCFwithDmaModeInBL	; ...perform the transfer in one operation
 
 	; Calculate how much we can transfer on first and second rounds
@@ -108,6 +108,4 @@
 	call	StartDMAtransferForXTCFwithDmaModeInBL
 	pop		cx										; Pop size for second DMA page
-
-.TransferLastDmaPageWithSizeInCX:
 	; Fall to StartDMAtransferForXTCFwithDmaModeInBL
 
@@ -115,5 +113,4 @@
 ;--------------------------------------------------------------------
 ; StartDMAtransferForXTCFwithDmaModeInBL
-; Updated for XT-CFv3, 11-Apr-13
 ;	Parameters:
 ;		BL:		Byte for DMA Mode Register
Index: /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdePioBlock.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdePioBlock.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdePioBlock.asm	(revision 589)
@@ -29,7 +29,5 @@
 ; --------------------------------------------------------------------------------------------------
 
-
 %ifdef MODULE_8BIT_IDE
-
 ;--------------------------------------------------------------------
 ; IdePioBlock_ReadFromXtideRev1
@@ -57,8 +55,7 @@
 
 ;--------------------------------------------------------------------
+; 8-bit PIO from a single data port.
+;
 ; IdePioBlock_ReadFrom8bitDataPort
-;
-; 8-bit PIO from a single data port.
-;
 ;	Parameters:
 ;		CX:		Block size in 512 byte sectors
@@ -68,5 +65,5 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, BX, CX
+;		AX, CX
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -87,13 +84,12 @@
 	ret
 %endif
-
-%endif	; MODULE_8BIT_IDE
-
-
-;--------------------------------------------------------------------
+%endif ; MODULE_8BIT_IDE
+
+
+;--------------------------------------------------------------------
+; 16-bit and 32-bit PIO from a single data port.
+;
 ; IdePioBlock_ReadFrom16bitDataPort
-;
-; 16-bit PIO from a single data port.
-;
+; IdePioBlock_ReadFrom32bitDataPort
 ;	Parameters:
 ;		CX:		Block size in 512 byte sectors
@@ -103,10 +99,10 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, BX, CX
+;		AX, CX
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 IdePioBlock_ReadFrom16bitDataPort:
 %ifdef USE_186
-	xchg	cl, ch	; Sectors to WORDs
+	xchg	cl, ch		; Sectors to WORDs
 	rep insw
 	ret
@@ -126,14 +122,11 @@
 
 ;--------------------------------------------------------------------
+%ifdef MODULE_ADVANCED_ATA
 ALIGN JUMP_ALIGN
 IdePioBlock_ReadFrom32bitDataPort:
-	db		0C1h		; SHL
-	db		0E1h		; CX
-	db		7			; 7 (Sectors to DWORDs)
-	rep
-	db		66h			; Override operand size to 32-bit
-	db		6Dh			; INSW/INSD
-	ret
-
+	shl		cx, 7		; Sectors to DWORDs
+	rep insd
+	ret
+%endif ; MODULE_ADVANCED_ATA
 
 
@@ -145,5 +138,4 @@
 
 %ifdef MODULE_8BIT_IDE
-
 ;--------------------------------------------------------------------
 ; IdePioBlock_WriteToXtideRev1
@@ -151,5 +143,5 @@
 ;		CX:		Block size in 512-byte sectors
 ;		DX:		IDE Data port address
-;		ES:SI:	Normalized ptr to buffer containing data
+;		DS:SI:	Normalized ptr to buffer containing data
 ;	Returns:
 ;		Nothing
@@ -159,9 +151,6 @@
 ALIGN JUMP_ALIGN
 IdePioBlock_WriteToXtideRev1:
-	push	ds
 	UNROLL_SECTORS_IN_CX_TO_QWORDS
 	mov		bl, 8		; Bit mask for toggling data low/high reg
-	push	es
-	pop		ds
 ALIGN JUMP_ALIGN
 .OutswLoop:
@@ -170,5 +159,4 @@
 	%endrep
 	loop	.OutswLoop
-	pop		ds
 	ret
 
@@ -179,16 +167,13 @@
 ;		CX:		Block size in 512-byte sectors
 ;		DX:		IDE Data port address
-;		ES:SI:	Normalized ptr to buffer containing data
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		AX, BX, CX
+;		DS:SI:	Normalized ptr to buffer containing data
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 IdePioBlock_WriteToXtideRev2:
 	UNROLL_SECTORS_IN_CX_TO_QWORDS
-	push	ds
-	push	es
-	pop		ds
 ALIGN JUMP_ALIGN
 .WriteNextQword:
@@ -197,5 +182,4 @@
 	%endrep
 	loop	.WriteNextQword
-	pop		ds
 	ret
 
@@ -206,9 +190,9 @@
 ;		CX:		Block size in 512-byte sectors
 ;		DX:		IDE Data port address
-;		ES:SI:	Normalized ptr to buffer containing data
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		AX, BX, CX
+;		DS:SI:	Normalized ptr to buffer containing data
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -216,5 +200,4 @@
 %ifdef USE_186
 	shl		cx, 9		; Sectors to BYTEs
-	es					; Source is ES segment
 	rep outsb
 	ret
@@ -222,7 +205,4 @@
 %else ; 808x
 	UNROLL_SECTORS_IN_CX_TO_QWORDS
-	push	ds
-	push	es
-	pop		ds
 ALIGN JUMP_ALIGN
 .WriteNextQword:
@@ -232,8 +212,6 @@
 	%endrep
 	loop	.WriteNextQword
-	pop		ds
-	ret
-%endif
-
+	ret
+%endif
 %endif ; MODULE_8BIT_IDE
 
@@ -245,9 +223,9 @@
 ;		CX:		Block size in 512-byte sectors
 ;		DX:		IDE Data port address
-;		ES:SI:	Normalized ptr to buffer containing data
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		AX, BX, CX
+;		DS:SI:	Normalized ptr to buffer containing data
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -255,5 +233,4 @@
 %ifdef USE_186
 	xchg	cl, ch		; Sectors to WORDs
-	es					; Source is ES segment
 	rep outsw
 	ret
@@ -261,7 +238,4 @@
 %else ; 808x
 	UNROLL_SECTORS_IN_CX_TO_QWORDS
-	push	ds
-	push	es
-	pop		ds
 ALIGN JUMP_ALIGN
 .WriteNextQword:
@@ -271,17 +245,13 @@
 	%endrep
 	loop	.WriteNextQword
-	pop		ds
-	ret
-%endif
-
-;--------------------------------------------------------------------
+	ret
+%endif
+
+;--------------------------------------------------------------------
+%ifdef MODULE_ADVANCED_ATA
 ALIGN JUMP_ALIGN
 IdePioBlock_WriteTo32bitDataPort:
-	db		0C1h		; SHL
-	db		0E1h		; CX
-	db		7			; 7 (Sectors to DWORDs)
-	es					; Source is ES segment
-	rep
-	db		66h			; Override operand size to 32-bit
-	db		6Fh			; OUTSW/OUTSD
-	ret
+	shl		cx, 7		; Sectors to DWORDs
+	rep outsd
+	ret
+%endif ; MODULE_ADVANCED_ATA
Index: /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeTransfer.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeTransfer.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeTransfer.asm	(revision 589)
@@ -173,6 +173,9 @@
 	cmp		[bp+PIOVARS.bSectorsLeft], cl
 	jbe		SHORT .WriteLastBlockToDrive
+	push	ds
+	push	es
+	pop		ds
 	call	[bp+PIOVARS.fnXfer]
-
+	pop		ds
 	; Wait until ready for next block and check for errors
 	call	IdeWait_IRQorDRQ					; Wait until ready to transfer
@@ -189,5 +192,9 @@
 	mov		cl, [bp+PIOVARS.bSectorsLeft]		; CH is already zero
 	push	cx
+	push	ds
+	push	es
+	pop		ds
 	call	[bp+PIOVARS.fnXfer]					; Transfer possibly partial block
+	pop		ds
 	jmp		SHORT CheckErrorsAfterTransferringLastBlock
 
@@ -237,5 +244,4 @@
 	; Convert ES:SI to physical address
 %ifdef USE_386
-
 	mov		dx, es
 	xor		ax, ax
@@ -247,52 +253,26 @@
 
 %elifdef USE_186
-						; Bytes	EU Cycles(286)
-	mov		ax, es		; 2		2
-	rol		ax, 4		; 3		9
-	mov		dx, ax		; 2		2
-	and		ax, BYTE 0Fh; 3		3
-	xor		dx, ax		; 2		2
-	add		si, dx		; 2		2
-	adc		al, ah		; 2		2
-	mov		es, ax		; 2		2
-	;------------------------------------
-						; 18	24
+	mov		ax, es
+	rol		ax, 4
+	mov		dx, ax
+	and		ax, 0Fh
+	xor		dx, ax
+	add		si, dx
+	adc		al, ah
+	mov		es, ax
+
 %else ; 808x
-						; Bytes	EU Cycles(808x)
-	mov		al, 4		; 2		4
-	mov		dx, es		; 2		2
-	xchg	cx, ax		; 1		3
-	rol		dx, cl		; 2		24
-	mov		cx, dx		; 2		2
-	xchg	cx, ax		; 1		3
-	and		ax, BYTE 0Fh; 3		4
-	xor		dx, ax		; 2		3
-	add		si, dx		; 2		3
-	adc		al, ah		; 2		3
-	mov		es, ax		; 2		2
-	;------------------------------------
-						; 21	53
-;
-; Judging by the Execution Unit cycle count the above block of code is
-; apparently slower. However, the shifts and rotates in the block below
-; execute faster than the Bus Interface Unit on an 8088 can fetch them,
-; thus causing the EU to starve. The difference in true execution speed
-; (if any) might not be worth the extra 5 bytes.
-; In other words, we could use a real world test here.
-;
-%if 0
-						; Bytes	EU Cycles(808x/286)
-	xor		dx, dx		; 2		3/2
-	mov		ax, es		; 2		2/2
-%rep 4
-	shl		ax, 1		; 8		8/8
-	rcl		dx, 1		; 8		8/8
-%endrep
-	add		si, ax		; 2		3/2
-	adc		dl, dh		; 2		3/2
-	mov		es, dx		; 2		2/2
-	;------------------------------------
-						; 26	29/26
-%endif ; 0
+	mov		al, 4
+	mov		dx, es
+	xchg	cx, ax
+	rol		dx, cl
+	mov		cx, dx
+	xchg	cx, ax
+	and		ax, 0Fh
+	xor		dx, ax
+	add		si, dx
+	adc		al, ah
+	mov		es, ax
+
 %endif
 
@@ -334,7 +314,11 @@
 %ifdef USE_AT		; CF is always clear for XT builds
 	; AH = RET_HD_INVALID (01) if CF set, RET_HD_SUCCESS (00) if not. CF unchanged.
+%ifdef USE_386
+	setc	ah
+%else
 	sbb		ah, ah
 	neg		ah
 %endif
+%endif ; USE_AT
 	ret
 
@@ -345,5 +329,9 @@
 g_rgfnPioRead:
 		dw		IdePioBlock_ReadFrom16bitDataPort	; 0, DEVICE_16BIT_ATA
+%ifdef MODULE_ADVANCED_ATA
 		dw		IdePioBlock_ReadFrom32bitDataPort	; 1, DEVICE_32BIT_ATA
+%elifdef MODULE_8BIT_IDE
+		dw		NULL
+%endif ; MODULE_ADVANCED_ATA
 %ifdef MODULE_8BIT_IDE
 		dw		IdePioBlock_ReadFrom8bitDataPort	; 2, DEVICE_8BIT_ATA
@@ -361,5 +349,9 @@
 g_rgfnPioWrite:
 		dw		IdePioBlock_WriteTo16bitDataPort	; 0, DEVICE_16BIT_ATA
+%ifdef MODULE_ADVANCED_ATA
 		dw		IdePioBlock_WriteTo32bitDataPort	; 1, DEVICE_32BIT_ATA
+%elifdef MODULE_8BIT_IDE
+		dw		NULL
+%endif ; MODULE_ADVANCED_ATA
 %ifdef MODULE_8BIT_IDE
 		dw		IdePioBlock_WriteTo8bitDataPort		; 2, DEVICE_8BIT_ATA
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h.asm	(revision 589)
@@ -98,5 +98,13 @@
 %endif
 	cld									; String instructions to increment pointers
-	CREATE_FRAME_INTPACK_TO_SSBP	SIZE_OF_IDEPACK_WITHOUT_INTPACK
+	ePUSHA
+	push	ds
+	push	es
+%ifdef USE_386
+;	push	fs
+;	push	gs
+%endif
+	sub		sp, BYTE SIZE_OF_IDEPACK_WITHOUT_INTPACK
+	mov		bp, sp
 	call	RamVars_GetSegmentToDS
 
@@ -297,6 +305,14 @@
 	; on INT 13h to enable interrupts.
 	or		BYTE [bp+IDEPACK.intpack+INTPACK.flags+1], (FLG_FLAGS_IF>>8)
-	mov		sp, bp	; This makes possible to exit anytime, no matter what is on stack
-	RESTORE_FRAME_INTPACK_FROM_SSBP		SIZE_OF_IDEPACK_WITHOUT_INTPACK
+
+	lea		sp, [bp+SIZE_OF_IDEPACK_WITHOUT_INTPACK]
+%ifdef USE_386
+;	pop		gs
+;	pop		fs
+%endif
+	pop		es
+	pop		ds
+	ePOPA
+	iret
 
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH1Eh_XTCF.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH1Eh_XTCF.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH1Eh_XTCF.asm	(revision 589)
@@ -152,44 +152,4 @@
 
 
-%if 0
-	; We always need to enable 8-bit mode since 16-bit mode is restored
-	; when controller is reset (AH=00h or 0Dh)
-	ePUSH_T	bx, AH23h_Enable8bitPioMode
-
-	; Convert mode to device type (see XTCF.inc for full details)
-	and		ax, 3
-	jz		SHORT .Set8bitPioMode	; XTCF_8BIT_PIO_MODE = 0
-	dec		ax						; XTCF_8BIT_PIO_MODE_WITH_BIU_OFFLOAD = 1
-	jz		SHORT .Set8bitPioModeWithBIUOffload
-	dec		ax						; XTCF_16BIT_PIO_WITH_BIU_OFFLOAD = 2
-	jz		SHORT .Set16bitPioModeWithBIUOffload
-
-	; XTCF_DMA_MODE = 3
-	mov		BYTE [di+DPT_ATA.bDevice], DEVICE_8BIT_XTCF_DMA
-
-	; DMA transfers have limited block size
-	mov		al, [di+DPT_ATA.bBlockSize]
-	cmp		al, XTCF_DMA_MODE_MAX_BLOCK_SIZE
-	jbe		SHORT AH24h_SetBlockSize
-	mov		al, XTCF_DMA_MODE_MAX_BLOCK_SIZE
-	jmp		SHORT AH24h_SetBlockSize
-
-.Set16bitPioModeWithBIUOffload:
-	pop		bx								; Do not enable 8-bit PIO...
-	ePUSH_T	bx, AH23h_Disable8bitPioMode	; ...disable it instead
-	mov		al, DEVICE_8BIT_XTCF_PIO16_WITH_BIU_OFFLOAD
-	SKIP2B	bx
-
-.Set8bitPioMode:
-	mov		al, DEVICE_8BIT_XTCF_PIO8
-	SKIP2B	bx
-
-.Set8bitPioModeWithBIUOffload:
-	mov		al, DEVICE_8BIT_XTCF_PIO8_WITH_BIU_OFFLOAD
-	mov		[di+DPT_ATA.bDevice], al
-	ret
-%endif ; 0
-
-
 ;--------------------------------------------------------------------
 ; AH1Eh_GetCurrentXTCFmodeToAX
@@ -197,5 +157,5 @@
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
 ;	Returns:
-;		AX:		XT-CF mode (XTCF_8BIT_PIO_MODE, XTCF_8BIT_PIO_MODE_WITH_BIU_OFFLOAD, XTCF_16BIT_PIO_WITH_BIU_OFFLOAD or XTCF_DMA_MODE)
+;		AX:		XT-CF mode (see XTCF.inc)
 ;		CF:		Clear
 ;	Corrupts registers:
@@ -208,9 +168,2 @@
 	ret
 
-%if 0
-	mov		al, [di+DPT_ATA.bDevice]
-	shr		al, 1
-	cbw
-	sub		al, XTCF_DEVICE_OFFSET >> 1
-	ret
-%endif ; 0
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH23h_HFeatures.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH23h_HFeatures.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH23h_HFeatures.asm	(revision 589)
@@ -92,4 +92,6 @@
 	mov		si, FEATURE_ENABLE_8BIT_PIO_TRANSFER_MODE
 	jmp		SHORT AH23h_SetControllerFeatures
+
+%ifdef MODULE_8BIT_IDE_ADVANCED
 AH23h_Disable8bitPioMode:
 	mov		si, FEATURE_DISABLE_8BIT_PIO_TRANSFER_MODE
@@ -97,3 +99,4 @@
 	xor		ah, ah			; Clear error since modern drives might not understand the command and are
 	ret						; always in 16-bit mode anyway
-%endif
+%endif ; MODULE_8BIT_IDE_ADVANCED
+%endif ; MODULE_8BIT_IDE
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH9h_HInit.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH9h_HInit.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH9h_HInit.asm	(revision 589)
@@ -184,6 +184,6 @@
 
 	; Advanced PIO mode 3 and above
-	mov		dl, [di+DPT_ADVANCED_ATA.bPioMode]
-	or		dl, PIO_FLOW_CONTROL_MODE_xxx
+	mov		dl, PIO_FLOW_CONTROL_MODE_xxx
+	or		dl, [di+DPT_ADVANCED_ATA.bPioMode]
 
 .IordyNotSupported:
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Tools/Address.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Tools/Address.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Tools/Address.asm	(revision 589)
@@ -174,13 +174,9 @@
 	; +=sectToSeek-1 (24-bit result)
 	; Max = 16,450,497 + 63 - 1 = 16,450,559 = FB03FFh
-	xor		bh, bh					; Sector number now in BX
+	mov		bh, ch					; Sector number now in BX, CH=zero
 	dec		bx						; sectToSeek-=1
-	add		ax, bx					; Add to loword
-	adc		dl, bh					; Add possible carry to byte2, BH=zero
-
-	; Copy DX:AX to proper return registers
-	xchg	bx, ax					; BL = Sector Number Register (LBA 7...0)
-	mov		cl, bh					; Low Cylinder Register (LBA 15...8)
-	mov		ch, dl					; High Cylinder Register (LBA 23...16)
-	mov		bh, dh					; Drive and Head Register (LBA 27...24)
+	add		bx, ax					; Add loword to BX (BL = Sector Number Register (LBA 7...0))
+	adc		ch, dl					; Add possible carry to byte2 (CH = High Cylinder Register (LBA 23...16))
+	mov		cl, bh					; CL = Low Cylinder Register (LBA 15...8)
+	mov		bh, dh					; BH = Drive and Head Register (LBA 27...24)
 	ret
Index: /trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/AdvAtaInit.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/AdvAtaInit.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/AdvAtaInit.asm	(revision 589)
@@ -37,15 +37,19 @@
 AdvAtaInit_DetectControllerForIdeBaseInBX:
 	call	Vision_DetectAndReturnIDinAXandPortInDXifControllerPresent
-	jne		SHORT .NoAdvancedControllerForPortBX
+	jnz		SHORT .NoVisionControllerFound
+
 	call	Vision_DoesIdePortInBXbelongToControllerWithIDinAX
-	jne		SHORT .NoAdvancedControllerForPortBX
+	jz		SHORT .AdvancedControllerFoundForPortBX
+
+.NoVisionControllerFound:
 	call	PDC20x30_DetectControllerForIdeBaseInBX
 	jnc		SHORT .NoAdvancedControllerForPortBX
 
-	stc		; Advanced Controller found for port BX
+.AdvancedControllerFoundForPortBX:
+	stc
 	ret
 
 .NoAdvancedControllerForPortBX:
-	xor		ax, ax
+	xor		ax, ax		; Clear ID in AX and CF
 	ret
 
@@ -66,8 +70,13 @@
 AdvAtaInit_GetControllerMaxPioModeToALandMinPioCycleTimeToBX:
 	cmp		ah, ID_QD6580_ALTERNATE
+%ifdef USE_386
+	jae		Vision_GetMaxPioModeToALandMinCycleTimeToBX
+	jmp		PDC20x30_GetMaxPioModeToALandMinPioCycleTimeToBX
+%else
 	jae		SHORT .Vision
 	jmp		PDC20x30_GetMaxPioModeToALandMinPioCycleTimeToBX
 .Vision:
 	jmp		Vision_GetMaxPioModeToALandMinCycleTimeToBX
+%endif
 
 
@@ -88,5 +97,5 @@
 	test	ax, ax
 	jz		SHORT .NoAdvancedController	; Return with CF cleared
-	
+
 	cmp		ah, ID_QD6580_ALTERNATE
 	jae		SHORT .Vision
@@ -98,5 +107,5 @@
 
 	call	AdvAtaInit_LoadMasterDPTtoDSSIifSlaveInDSDI
-	call	Vision_InitializeWithIDinAHandConfigInAL
+	call	Vision_InitializeWithIDinAH
 	xor		ax, ax						; Success
 
@@ -116,5 +125,5 @@
 ;				Zero if Slave Drive not present
 ;	Corrupts registers:
-;		AX
+;		AL
 ;--------------------------------------------------------------------
 AdvAtaInit_LoadMasterDPTtoDSSIifSlaveInDSDI:
Index: /trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/PDC20x30.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/PDC20x30.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/PDC20x30.asm	(revision 589)
@@ -36,9 +36,42 @@
 	mov		dx, bx
 	call	EnablePdcProgrammingMode
-	jz		.ControllerDetected
-	clc
-	ret
-.ControllerDetected:
-	call	GetPdcIDtoAX
+	jnz		SHORT DisablePdcProgrammingMode.Return	; PDC controller not detected
+;	ePUSH_T	ax, DisablePdcProgrammingMode			; Uncomment this if GetPdcIDtoAX needs to be a real function
+	; Fall to GetPdcIDtoAX
+
+;--------------------------------------------------------------------
+; Programming mode must be enabled for this function.
+; This function also enables PDC 20630 extra registers.
+;
+; GetPdcIDtoAX
+;	Parameters:
+;		DX:		IDE Base port
+;	Returns:
+;		AH:		PDC ID
+;	Corrupts registers:
+;		AL, BX
+;--------------------------------------------------------------------
+GetPdcIDtoAX:
+	push	dx
+
+	; Try to enable PDC 20630 extra registers
+	add		dx, BYTE LOW_CYLINDER_REGISTER
+	in		al, dx
+	or		al, FLG_PDCLCR_ENABLE_EXTRA_REGISTERS
+	out		dx, al
+
+	; Try to access PDC 20630 registers to see if they are available
+	; Hopefully this does not cause problems for systems with PDC 20230
+	add		dx, BYTE PDC20630_INDEX_REGISTER - LOW_CYLINDER_REGISTER
+	mov		al, PDCREG7_STATUS	; Try to access PDC 20630 status register
+	out		dx, al
+	xchg	bx, ax
+	in		al, dx				; Does index register contain status register index?
+	cmp		al, bl
+	mov		ah, ID_PDC20630
+	eCMOVNE	ah, ID_PDC20230
+
+	pop		dx
+;	ret							; Uncomment this to make GetPdcIDtoAX a real function
 	; Fall to DisablePdcProgrammingMode
 
@@ -49,5 +82,5 @@
 ;		DX:		Base port
 ;	Returns:
-;		Nothing
+;		CF:		Set
 ;	Corrupts registers:
 ;		AL
@@ -56,6 +89,6 @@
 	add		dx, BYTE HIGH_CYLINDER_REGISTER
 	in		al, dx
-	sub		dx, BYTE HIGH_CYLINDER_REGISTER
-	stc		; Set for PDC20x30_DetectControllerForIdeBaseInBX
+	add		dx, -HIGH_CYLINDER_REGISTER		; Sets CF for PDC20x30_DetectControllerForIdeBaseInBX
+.Return:
 	ret
 
@@ -66,4 +99,5 @@
 ;		DX:		Base port
 ;	Returns:
+;		CF:		Cleared
 ;		ZF:		Set if programming mode enabled
 ;	Corrupts registers:
@@ -72,6 +106,7 @@
 EnablePdcProgrammingMode:
 	; Set bit 7 to sector count register
-	add		dx, BYTE SECTOR_COUNT_REGISTER
-	in		al, dx
+	inc		dx
+	inc		dx
+	in		al, dx	; 1F2h (SECTOR_COUNT_REGISTER)
 	or		al, 80h
 	out		dx, al
@@ -93,38 +128,7 @@
 	; PDC20230C and PDC20630 clears the bit we set at the beginning
 	in		al, dx
-	sub		dx, BYTE SECTOR_COUNT_REGISTER
-	test	al, 80h
-	ret
-
-
-;--------------------------------------------------------------------
-; Programming mode must be enabled for this function.
-; This function also enables PDC 20630 extra registers.
-;
-; GetPdcIDtoAX
-;	Parameters:
-;		DX:		IDE Base port
-;	Returns:
-;		AX:		PDC ID word
-;	Corrupts registers:
-;		BX
-;--------------------------------------------------------------------
-GetPdcIDtoAX:
-	; Try to enable PDC 20630 extra registers
-	add		dx, BYTE LOW_CYLINDER_REGISTER
-	in		al, dx
-	or		al, FLG_PDCLCR_ENABLE_EXTRA_REGISTERS
-	out		dx, al
-
-	; Try to access PDC 20630 registers to see if they are available
-	; Hopefully this does not cause problems for systems with PDC 20230
-	add		dx, BYTE PDC20630_INDEX_REGISTER - LOW_CYLINDER_REGISTER
-	mov		al, PDCREG7_STATUS	; Try to access PDC 20630 status register
-	out		dx, al
-	xchg	bx, ax
-	in		al, dx				; Does index register contain status register index?
-	cmp		al, bl
-	mov		ah, ID_PDC20630
-	eCMOVNE	ah, ID_PDC20230
+	dec		dx
+	dec		dx		; Base port
+	test	al, 80h	; Clears CF
 	ret
 
@@ -145,9 +149,9 @@
 PDC20x30_GetMaxPioModeToALandMinPioCycleTimeToBX:
 	cmp		ah, ID_PDC20630
-	je		SHORT .return		; No need to limit anything
+	je		SHORT .Return		; No need to limit anything
 	mov		ax, 2				; Limit PIO to 2 for ID_PDC20230
 	mov		bx, PIO_2_MIN_CYCLE_TIME_NS
 	stc
-.return:
+.Return:
 	ret
 
@@ -165,7 +169,15 @@
 ;--------------------------------------------------------------------
 PDC20x30_InitializeForDPTinDSDI:
+%ifdef USE_386
+	xor		ch, ch
+	test	BYTE [di+DPT.bFlagsLow], FLGL_DPT_SLAVE
+	setnz	cl
+%else
 	xor		cx, cx
 	test	BYTE [di+DPT.bFlagsLow], FLGL_DPT_SLAVE
-	eCSETNZ	cl
+	jz		SHORT .NotSlave
+	inc		cx
+.NotSlave:
+%endif
 
 	mov		dx, [di+DPT.wBasePort]
@@ -173,7 +185,7 @@
 	call	SetSpeedForDriveInCX
 	cmp		BYTE [di+DPT_ADVANCED_ATA.wControllerID+1], ID_PDC20630
-	jne		.initializationCompleted
+	jne		SHORT .InitializationCompleted
 	call	SetPdc20630SpeedForDriveInCX
-.initializationCompleted:
+.InitializationCompleted:
 	mov		dx, [di+DPT.wBasePort]
 	call	DisablePdcProgrammingMode
@@ -201,15 +213,17 @@
 	mov		bh, ~MASK_PDCSCR_DEV1SPEED	; Assume slave
 	inc		cx
-	loop	.setSpeed
+	loop	.SetSpeed
 	eSHL_IM	bl, POS_PDCSCR_DEV0SPEED
 	mov		bh, ~MASK_PDCSCR_DEV0SPEED
-.setSpeed:
+.SetSpeed:
 	in		al, dx
 	and		al, bh
 	or		al, bl
 	cmp		bl, 7
-	jb		SHORT OutputNewValue
+	jb		SHORT .OutputNewValue
 	or		al, FLG_PDCSCR_UNKNOWN_BIT7	; Flag for PIO 2 and above?
-	jmp		SHORT OutputNewValue
+.OutputNewValue:
+	out		dx, al
+	ret
 
 .rgbPioModeToPDCspeedValue:
@@ -228,20 +242,18 @@
 ;		DX:		Low Cylinder Register
 ;	Corrupts registers:
-;		AX, CX
+;		AX
 ;--------------------------------------------------------------------
 SetPdc20630SpeedForDriveInCX:
 	inc		dx		; LOW_CYLINDER_REGISTER
-	mov		ah, FLG_PDCLCR_DEV0SPEED_BIT4 | FLG_PDCLCR_DEV0IORDY
-	shr		ah, cl
-	in		al, dx
-	not		ah
+	mov		ah, ~(FLG_PDCLCR_DEV0SPEED_BIT4 | FLG_PDCLCR_DEV0IORDY)
+	ror		ah, cl
+	in		al, dx
 	and		al, ah	; Clear drive specific bits
 	cmp		BYTE [di+DPT_ADVANCED_ATA.bPioMode], 2
-	jbe		.clearBitsOnly
+	jbe		.ClearBitsOnly
 	not		ah
 	or		al, ah
-.clearBitsOnly:
-OutputNewValue:
-	out		dx, al
-	ret
-
+.ClearBitsOnly:
+	out		dx, al
+	ret
+
